package sketch;

import java.util.ArrayList;

import kmer.AbstractKmerTable;

public class Blacklist extends SketchObject {
	
	public static void addFile(String fname, SketchTool tool0){
		System.err.println("Adding "+fname+" to blacklist.");
		SketchTool tool=new SketchTool(1000000, tool0.k, 1, tool0.rcomp);
		if(keySets==null){
			keySets=AbstractKmerTable.preallocate(ways, AbstractKmerTable.ARRAY1D, initialSize, true);
		}
//		FileFormat ff=FileFormat.testInput(fname, FileFormat.SKETCH, (String)null, true, true);
		ArrayList<Sketch> sketches=tool.loadSketches(fname, null, ONE_SKETCH);
		for(Sketch sk : sketches){
			for(long key : sk.array){
				increment(Long.MAX_VALUE-key);
			}
		}
	}
	
	public static int increment(long key){
		int way=(int)(key%ways);
		return keySets[way].increment(key);
	}
	
	public static boolean contains(long key){
		if(keySets==null){return false;}
		int way=(int)(key%ways);
		return keySets[way].getValue(key)>0;
	}
	
	public static boolean exists(){
		return keySets!=null;
	}
	
	/** Hold kmers.  A kmer X such that X%WAYS=Y will be stored in keySets[Y] */
	private static AbstractKmerTable[] keySets;
	private static final int ways=7;
	private static final int initialSize=16000;
	
}
